local name, addon = ...
local parentName = addon['parentName'] or "BrokerPack"
local childName = "zz_Worldboss"
local realm = GetRealmName()
local player = UnitName('player').."-"..realm
local faction
local maxlevel = 100
local curVersion = 6000
local db
local fmt = "|c0000ff00%s|r |c00ffffff%s|r"
local defaults = {
	['expansions'] = {
		['WoD'] = {
			['name'] = "Warlords of Draenor",
			['active'] = true,
			['minlevel'] = 100,
			['maxlevel'] = 100,
		},['WoD-Seals'] = {
			['name'] = "WoD Seals",
			['active'] = true,
			['minlevel'] = 100,
			['maxlevel'] = 100,
		},
	},
	['quests'] = {
		[37255] = {
			['active'] = true,
			['name'] = "Coliseum Winner Flag",
			['minlevel'] = 100,
			['expansion'] = 'WoD',
		},
		[37308] = {
			['active'] = true,
			['name'] = "Garrison Invasion Bronze",
			['minlevel'] = 100,
			['expansion'] = 'WoD',
		},
		[37309] = {
			['active'] = true,
			['name'] = "Garrison Invasion Silver",
			['minlevel'] = 100,
			['expansion'] = 'WoD',
		},
		[37310] = {
			['active'] = true,
			['name'] = "Garrison Invasion Gold",
			['minlevel'] = 100,
			['expansion'] = 'WoD',
		},
		[37307] = {
			['active'] = true,
			['name'] = "Gold Victory (A)",
			['faction'] = "Alliance",
			['minlevel'] = 100,
			['expansion'] = 'WoD',
		},
		[35788] = {
			['active'] = true,
			['name'] = "Gold Victory (H)",
			['faction'] = "Horde",
			['minlevel'] = 100,
			['expansion'] = 'WoD',
		},
		[37305] = {
			['active'] = true,
			['name'] = "Bronze Victory (A)",
			['faction'] = "Alliance",
			['minlevel'] = 100,
			['expansion'] = 'WoD',
		},
		[35786] = {
			['active'] = true,
			['name'] = "Bronze Victory (H)",
			['faction'] = "Horde",
			['minlevel'] = 100,
			['expansion'] = 'WoD',
		},
		[36055] = {
			['group'] = {
				[36058] = {
					['name'] = "Armory",
				},
				[36055] = {
					['name'] = "Apexis 1",
				},
				[37452] = {
					['name'] = "Apexis 2",
				},
				[37453] = {
					['name'] = "Apexis 3",
				},
				[36057] = {
					['name'] = "Honor 1",
				},
				[37458] = {
					['name'] = "Honor 2",
				},
				[37459] = {
					['name'] = "Honor 3",
				},
				[36056] = {
					['name'] = "Resources 1",
				},
				[37456] = {
					['name'] = "Resources 2",
				},
				[37457] = {
					['name'] = "Resources 3",
				},
				[36054] = {
					['name'] = "Gold 1",
				},
				[37454] = {
					['name'] = "Gold 2",
				},
				[37455] = {
					['name'] = "Gold 3",
				},
			},
			['groupmaxcount'] = 3,
			['active'] = true,
			['name'] = "Seals",
			['minlevel'] = 90,
			['expansion'] = 'WoD-Seals',
		},
		[36834] = {
			['active'] = true,
			['name'] = "Gorgrond Ogre Gateway",
			['minlevel'] = 100,
			['expansion'] = 'WoD',
		},
		[37462] = {
			['active'] = true,
			['name'] = "Tarlna the Ageless",
			['minlevel'] = 100,
			['expansion'] = 'WoD',
		},
		[37463] = {
			['active'] = false,
			['name'] = "SPR 2",
			['minlevel'] = 100,
			['expansion'] = 'WoD',
		},
		[37464] = {
			['active'] = true,
			['name'] = "Rukhmar",
			['minlevel'] = 100,
			['expansion'] = 'WoD',
		},
		[37465] = {
			['active'] = false,
			['name'] = "SPR 4",
			['minlevel'] = 100,
			['expansion'] = 'WoD',
		},
		[37675] = {
			['active'] = false,
			['name'] = "Tarlna bonus",
			['minlevel'] = 100,
			['expansion'] = 'WoD',
		},
		[37460] = {
			['active'] = true,
			['name'] = "Drov the Ruiner",
			['minlevel'] = 100,
			['expansion'] = 'WoD',
		},
		[37672] = {
			['active'] = false,
			['name'] = "Rukhmar bonus", -- Rukhmar bonus loot ??? http://de.wowhead.com/spell=178852
			['minlevel'] = 100,
			['expansion'] = 'WoD',
		},
		[37673] = {
			['active'] = false,
			['name'] = "Drov bonus",
			['minlevel'] = 100,
			['expansion'] = 'WoD',
		},
		[37461] = {
			['active'] = false,
			['name'] = "SPR 9",
			['minlevel'] = 100,
			['expansion'] = 'WoD',
		},
		[37681] = {
			['active'] = false,
			['name'] = "SPR 10",
			['minlevel'] = 100,
			['expansion'] = 'WoD',
		},
		[37682] = {
			['active'] = false,
			['name'] = "SPR 11",
			['minlevel'] = 100,
			['expansion'] = 'WoD',
		},
		[37683] = {
			['active'] = false,
			['name'] = "SPR 12",
			['minlevel'] = 100,
			['expansion'] = 'WoD',
		},
		[37684] = {
			['active'] = false,
			['name'] = "SPR 13",
			['minlevel'] = 100,
			['expansion'] = 'WoD',
		},
		[37639] = {
			['active'] = true,
			['name'] = "Silver Tracker",
			['minlevel'] = 100,
			['expansion'] = 'WoD',
		},
		[37306] = {
			['active'] = true,
			['faction'] = "Alliance",
			['name'] = "Silver Victory",
			['minlevel'] = 100,
			['expansion'] = 'WoD',
		},
		[35787] = {
			['active'] = true,
			['faction'] = "Horde",
			['name'] = "Silver Victory",
			['minlevel'] = 100,
			['expansion'] = 'WoD',
		},
		[37284] = {
			['active'] = true,
			['name'] = "Da Big Score",
			['minlevel'] = 90,
			['expansion'] = 'WoD',
		},
		[36395] = {
			['active'] = true,
			['name'] = "Treasure 003",
			['minlevel'] = 90,
			['expansion'] = 'WoD',
		},
		[36397] = {
			['active'] = true,
			['name'] = "Treasure 019",
			['minlevel'] = 90,
			['expansion'] = 'WoD',
		},
		[36398] = {
			['active'] = true,
			['name'] = "Treasure 027",
			['minlevel'] = 90,
			['expansion'] = 'WoD',
		},
		[36399] = {
			['active'] = true,
			['name'] = "Treasure 031",
			['minlevel'] = 90,
			['expansion'] = 'WoD',
		},
		[36400] = {
			['active'] = true,
			['name'] = "Treasure 034",
			['minlevel'] = 90,
			['expansion'] = 'WoD',
		},
		[36401] = {
			['active'] = true,
			['name'] = "Treasure 048",
			['minlevel'] = 90,
			['expansion'] = 'WoD',
		},
	},
	['hideRealm'] = true,
	['sameRealm'] = true,
	['char_db'] = {},
}
local function groupQuest(group)
	local db = {}
	for k, v in pairs(group) do
		 db[k] = IsQuestFlaggedCompleted(k) and true or nil
	end
	return db
end
local function update()
  if(db['quests']) then
	for questId, questData in pairs(db['quests']) do
--		print(player..":"..questId.." "..tostring(questData['minlevel']) .. "-".. tostring(db['char_db'][player]['level']))
		if(not questData['faction'] or questData['faction'] == faction) then
			if(questData['minlevel'] <= db['char_db'][player]['level']) then
				if(questData['group']) then
					db['char_db'][player][questId] = groupQuest(questData['group'])
				else
					db['char_db'][player][questId] = IsQuestFlaggedCompleted(questId) and true or nil
				end
			end
			if(questData['location']) then
				local pin = addon['getPin'](name.."_quest_"..questId,questData['x'],questData['y'],questData['location'],questData['name'],questData['icon'] or 'Interface\\WorldMap\\TreasureChest_64')
				if(db['char_db'][player][questId]) then
					addon['removePin'](name.."_quest_"..questId)
				end
			end
		end
	end
  end
end

local function onupdate(self,dt)
	self['elapsed'] = (self['elapsed'] or 0) - dt
	if(self['elapsed'] < 0) then
		self['elapsed'] = 5
		update()
	end
end
local function event(self,evnt,...)
	self:SetScript("OnUpdate", onupdate)
	if(evnt == "PLAYER_REGEN_DISABLED") then
		self:SetScript("OnUpdate", nil)
	else
		update()
	end
end
local function reset()
	for k,v in pairs(db['char_db']) do
		for a,b in pairs(v) do
			if(a ~= 'level' and a~= 'class') then
				v[a] = nil
			end
		end
	end
	update()
end
local function countQuestData(charData)
	local count = 0
	for k,v in pairs(charData) do
		if(v) then
			count = count + 1
		end
	end
	return count
end
local function checkQuestData(questData, charData)
	if(type(charData) == "table") then
		return countQuestData(charData) >= questData['groupmaxcount']
	else
		return charData
	end
end
local function OnTooltip(GameTooltip)
	if(db['expansions']) then
		for expansion, info in pairs(db['expansions']) do
			if(info['active'] and db['char_db'][player]['level'] >= info['minlevel'] and db['char_db'][player]['level'] <= info['maxlevel']) then
				local zztip = type(GameTooltip.AddHeader) == 'function' and GameTooltip:AddHeader(info['name']) or GameTooltip:AddLine(info['name'])
				for charName, charData in pairs(db['char_db']) do
					local cn,cr = strsplit("-",charName,2)
					local cdn = db['hideRealm'] and cn or charName
					if(charData['level'] >= info['minlevel']) then
						local line = ""
						local nd = false
						for questId, questData in pairs(db['quests']) do
							if(questData['expansion'] == expansion and charData['level'] >= questData['minlevel']) then
								if(questData['active']) then
									if( line ~= "") then
										line = line .. "/"
									end
									local newline = line .. addon['colorize'](questData['group'] and questData['name'] .. " "..countQuestData(charData[questId]).."/"..questData['groupmaxcount'] or questData['name'], checkQuestData(questData,charData[questId]) and '00ff00' or 'ff0000')
									if(strlen(newline)<=(db['wraplength'] or 200)) then
										line = newline
									else
										GameTooltip:AddDoubleLine(nd and " " or (addon['classcolor'](cdn,(charData['class']))), line)
										nd = true
										line = ""
									end
--									GameTooltip:AddDoubleLine(" -",addon['colorize'](questData['name'], charData[questId] and '00ff00' or 'ff0000'))
								end
							end
						end
						if(line ~= "" and (((db['sameRealm'] and cr == realm) and true or false) or not db['sameRealm'])) then
							GameTooltip:AddDoubleLine(nd and " " or (addon['classcolor'](cdn,(charData['class']))),(line))
						end
					end
				end
			end
		end
	end
	GameTooltip:AddLine("")
	GameTooltip:AddLine(format(fmt,"CTRL+Leftclick","Reset Quests"))
end
local function setQuestPref(info,value)
	local val, quest = strsplit("_",info[#info],2)
	if(tostring(val) == 'quest') then
		return
	elseif(tostring(val) == 'minlevel') then
		db['quests'][tonumber(quest)][tostring(val)] = tonumber(value)
	else
		db['quests'][tonumber(quest)][tostring(val)] = value
	end
	addon['updatePrefs']()
end
local function getQuestPref(info)
	local val, quest = strsplit("_",info[#info],2)
	if(tostring(val) == 'quest') then
		return tostring(quest)
	elseif(tostring(val) == 'minlevel') then
		if(db['quests'] and db['quests'][tonumber(quest)]) then
			return tostring(db['quests'][tonumber(quest)][tostring(val)])
		else
			return nil
		end
	end
	if(db['quests'] and db['quests'][tonumber(quest)]) then
		return db['quests'] and db['quests'][tonumber(quest)][tostring(val)] or nil
	end
end
local function getExpansionPref(info)
	local val, expansion = strsplit("_",info[#info],2)
	if(val=='add') then
		return ""
	elseif(expansion and db['expansions']) then
		if((val == 'minlevel') or (val == 'maxlevel')) then
			return tostring(db['expansions'][expansion][val])
		else
			return db['expansions'][expansion][val]
		end
	end
end
local function setExpansionPref(info,value)
	local val, expansion = strsplit("_",info[#info],2)
	if(val == 'add') then
		local q = tonumber(value)
		if(q  and q > 0 and not db['quests'][q]) then
			db['quests'][q] = {
				['active'] = true,
				['name'] = "Quest "..tostring(q),
				['minlevel'] = maxlevel,
				['expansion'] = expansion,
			}
		end
	else
		if((val == 'minlevel') or (val == 'maxlevel')) then
			db['expansions'][expansion][val] = tonumber(value)
		else
			db['expansions'][expansion][val] = value
		end
	end
	addon['updatePrefs']()
end
local function removeQuest(info)
	local _, quest = strsplit("_",info[#info],2)
	if(tonumber(quest) > 0 and db['quests'][tonumber(quest)]) then
		db['quests'][tonumber(quest)] = nil
		addon['updatePrefs']()
	end
end
local function removeExpansion(info)
	local _, expansion = strsplit("_",info[#info],2)
	if(tostring(expansion) and db['expansions'][tostring(expansion)]) then
		db['expansions'][tostring(expansion)] = nil
		for quest,qTab in pairs(db['quests']) do
			if(qTab['expansion'] == expansion) then
				db['quests'][tonumber(quest)] = nil
			end
		end
		addon['updatePrefs']()
	end
end
local function restoreDefaults()
	addon['db']['profile'][childName] = CopyTable(defaults)
	db = addon['db']['profile'][childName]
	db['char_db'][player] = db['char_db'][player] or {}
	db['char_db'][player]['level'] = UnitLevel('player')
	local _, class, _ = UnitClass('player')
	db['char_db'][player]['class'] = class
	addon['updatePrefs']()
end
addon['updatePrefs'] = function()
	local p = addon['options']['args']['Expansions']
	wipe(p['args'])
	addon['AddConfigEntry'](addon,childName,'input','add',"Add Expansion","",1,nil,nil,nil,nil,p)
	for expansion, tab in pairs(db['expansions'] or {}) do
		local menu = addon['AddConfigMenu'](addon,{
			['name'] = expansion,
			['order'] = 2,
			['childGroups'] = 'tree',
			['args'] = {},
			['menuGet'] = getExpansionPref,
			['menuSet'] = setExpansionPref,
		}, p)
		addon['AddConfigEntry'](addon,childName,'toggle','active_'..expansion,"Active","",1,nil,nil,nil,nil,menu)
		addon['AddConfigEntry'](addon,childName,'input','name_'..expansion,"Name","Display Name of the expansion",2,nil,nil,nil,nil,menu)
		addon['AddConfigEntry'](addon,childName,'input','minlevel_'..expansion,"Min Level","Minimum level to complete the quest",3,nil,nil,nil,nil,menu)
		addon['AddConfigEntry'](addon,childName,'input','maxlevel_'..expansion,"Max Level","Maximum level to display the quest",4,nil,nil,nil,nil,menu)
		addon['AddConfigEntry'](addon,childName,'header','head1',"Add Quest","",5,nil,nil,nil,nil,menu)
		addon['AddConfigEntry'](addon,childName,'input','add_'..expansion,"Add Id","Add QuestId - Keep in mind that some quests are factionspecific.",6,nil,nil,nil,nil,menu)
		for quest, qTab in pairs(db['quests'] or {}) do
			if(qTab['expansion'] == expansion) then
				local submenu = addon['AddConfigMenu'](addon,{
					['name'] = addon['colorize'](qTab['name'],(qTab['active'] and "ffffff" or "ff0000")),
					['order'] = 7,
					['childGroups'] = 'tree',
					['args'] = {},
					['menuGet'] = getQuestPref,
					['menuSet'] = setQuestPref,
				}, menu)
				addon['AddConfigEntry'](addon,childName,'toggle','active_'..quest,"Active","",1,nil,nil,nil,nil,submenu)
				addon['AddConfigEntry'](addon,childName,'input','quest_'..quest,"QuestId","",2,nil,nil,nil,nil,submenu)
				addon['AddConfigEntry'](addon,childName,'input','name_'..quest,"Questname","",3,nil,nil,nil,nil,submenu)
				addon['AddConfigEntry'](addon,childName,'input','minlevel_'..quest,"Quest Minlevel","Minimum level to accept the quest",4,nil,nil,nil,nil,submenu)
				addon['AddConfigEntry'](addon,childName,'execute','deleteQuest_'..quest,"Remove","Remove quest",5,removeQuest,nil,nil,nil,submenu)
			end
		end
		addon['AddConfigEntry'](addon,childName,'header','head2',"Remove Expansion","",8,nil,nil,nil,nil,menu)
		addon['AddConfigEntry'](addon,childName,'execute','delete_'..expansion,"Remove","Remove expansion and all quests",9,removeExpansion,nil,nil,nil,menu)
	end
	addon['AddConfigEntry'](addon,childName,'execute','restore',"Restore","Undo all changes and restore default expansions and quests",3,restoreDefaults,nil,nil,nil,p)
	update()
end
local function getPref(info)
	return addon['db']['profile'][childName][info[#info]]
end
local function setPref(info,value)
	if(info[#info]=='add') then
		if(not db['expansions'][tostring(value)]) then
			db['expansions'][tostring(value)] = {
				['name'] = "NA",
				['active'] = true,
				['minlevel'] = maxlevel,
				['maxlevel'] = maxlevel,
			}
		end
	else
		addon['db']['profile'][childName][info[#info]] = value
	end
	addon['updatePrefs']()
end
local function addNew()
	local steps = {

	}
	for a,b in pairs(steps) do
		if(a > db['version']) then
			db['quests'] = db['quests'] or {}
			for _,quest in pairs(b['quests']) do
				db['quests'][tonumber(quest)] = CopyTable(defaults['quests'][tonumber(quest)])
			end
		end
	end
	db['version'] = curVersion
end
local function ldbOnClick(self, button)
	if(button == "LeftButton" and IsControlKeyDown()) then
		reset()
	elseif(IsShiftKeyDown() and button == "LeftButton") then
		addon['db']['global']['ldbicons'][childName]['hide'] = not addon['db']['global']['ldbicons'][childName]['hide']
		if(ldbicon) then
			if(addon['db']['global']['ldbicons'][childName]['hide']) then 
				ldbicon:Hide(childName)
			else
				ldbicon:Show(childName)
			end
		end
	elseif(button == "LeftButton") then
		if(InterfaceOptionsFrame:IsVisible() and not InCombatLockdown()) then
			InterfaceOptionsFrame:Hide()
		else
			InterfaceOptionsFrame_OpenToCategory(childName)
		end
	end
end
local function init()
	faction = UnitFactionGroup("player")
	addon['options'] = addon['InitConfig'](addon, childName, true, {
		['name'] = childName,
		['type'] = "launcher",
		['icon'] = "Interface\\Icons\\ability_monk_roll",
		['OnTooltipShow'] = OnTooltip,
		['OnClick'] = ldbOnClick,
	}, getPref,setPref)
	db = addon['db']['profile'][childName]
	if(db['sha']) then
		restoreDefaults()
	end
	db['version'] = db['version'] or 0
	if(db['version'] < curVersion) then
		addNew()
	end
	db['char_db'][player] = db['char_db'][player] or {}
	db['char_db'][player]['level'] = UnitLevel('player')
	local _, class, _ = UnitClass('player')
	db['char_db'][player]['class'] = class
	addon['AddConfigMenu'](addon,{
		['name'] = "Expansions",
		['order'] = 2,
		['childGroups'] = 'tab',
		['menuGet'] = getPref,
		['menuSet'] = setPref,
		['args'] = {},
	}, addon['options'])
	addon['AddConfigEntry'](addon,childName,'toggle','hideRealm',"Hide Realm","Don't display realm in tooltip",1)
	addon['AddConfigEntry'](addon,childName,'toggle','sameRealm',"Same Realm only","Don't display other realms",2)
	addon['AddConfigEntry'](addon,childName,'range','wraplength',"Tooltip length","Wrap listed quests in tooltip",3,5,512,1,false)
	addon['AddConfigEntry'](addon,childName,'execute','resetData',"Reset","Reset stored quest status",3,reset)
	local _, _, _, loadable, reason, _, _ = GetAddOnInfo("zz_Wb_Pandaria")
	if(reason=="DEMAND_LOADED") then
		addon['AddConfigEntry'](addon,childName,'execute','importMoP',"Import MoP","Imports questdata for MoP-Expansion",4,function()
			LoadAddOn("zz_Wb_Pandaria")
			addon['updatePrefs']()
		end)
	end
	addon['updatePrefs']()
	addon['RegisterFunc']({"QUEST_LOG_UPDATE","PLAYER_LOGOUT","PLAYER_REGEN_DISABLED","PLAYER_REGEN_ENABLED"},"OnEvent", event)
end
addon['startup'](addon, name, childName, init, true, defaults)
